{
  lib ? (import <nixpkgs> { }).lib,
}:

let
  # pkgs stub to mock calls to pkgs 
  pkgs = rec {
    writeTextFile =
      {
        name,
        text,
        executable ? false,
        destination ? "",
        checkPhase ? "",
        meta ? { },
        allowSubstitutes ? false,
        preferLocalBuild ? true,
        derivationArgs ? { },
      }@set:
      set;
    writeTextDir =
      path: text:
      writeTextFile {
        inherit text;
        name = builtins.baseNameOf path;
        destination = "/${path}";
      };
    symlinkJoin = { name, paths }@set: set;
    stylua = "";
    vimPlugins.lazy-nvim = "";
  };
  luaUtils = import ../pkgs/luaUtils.nix { inherit lib pkgs; };
  lazyUtils = import ../pkgs/lazyUtils.nix { inherit lib pkgs luaUtils; };
in
{
  luaUtils = import ./luaUtils.nix { inherit luaUtils; };
  lazyUtils = import ./lazyUtils.nix { inherit lazyUtils; };
}
